package nnColor;

import com.nttdocomo.ui.*;
import com.nttdocomo.net.*;
import com.nttdocomo.io.*;
import com.nttdocomo.util.*;

import java.io.*;
import java.util.*;

import javax.microedition.io.*;


class NetscapeColorCanvas extends Canvas{
    int page;
    int selectY;
    NetscapeColorList colorList=new NetscapeColorList();

    boolean isHex;

    int textColor=Graphics.BLACK;
    /** Creates new NetscapeColorCanvas */
    public NetscapeColorCanvas() {
        setSoftLabel(Frame.SOFT_KEY_1,"Exit");
        setSoftLabel(Frame.SOFT_KEY_2,"");
    }

    public void drawStringInRect(Graphics g,Font font,String str,int x,int y,int width,int height){
        g.setFont(font);
        g.drawString(str,(width-font.stringWidth(str))/2+x,(height+font.getAscent())/2+y);
    }
/*
     public void drawStringInRect(Graphics g,Font font,String str,int x,int y,int width,int height){
        g.setFont(font);
        g.drawString(str,(width-font.stringWidth(str))/2+x,(height+font.getAscent())/2+y);
    }
    */
    
    public void changeColor(){
     if(textColor==Graphics.BLACK){
        setSoftLabel(Frame.SOFT_KEY_2,"");
        textColor=Graphics.WHITE;
    }else{
         setSoftLabel(Frame.SOFT_KEY_2,"");
        textColor=Graphics.BLACK;
        }
    }
    
        public int getRGBColor(int rgb){
    int r=(0xff0000 & rgb)>>16;   
    int g=(0x00ff00 & rgb)>>8;   
    int b=(0x0000ff & rgb)>>0;  
    return Graphics.getColorOfRGB(r,g,b);
    }
    public void paint(Graphics g){

        int recHeight=getHeight()/5;
        for(int i=0;i<5;i++){
            int color=colorList.getColorOfName((page*5+i+selectY)%140);
            
             g.setColor(getRGBColor(color));
            g.fillRect(0,i*recHeight,getWidth(),recHeight);
           
            String label="";

            if(isHex){
                label=getHex(color);
            }else{
                label=colorList.getNameAt((page*5+i+selectY)%140);
            }
            
            Font font=Font.getDefaultFont();
            if(font.stringWidth(label)>getWidth()){
                font=Font.getFont(Font.FACE_MONOSPACE|Font.STYLE_PLAIN|Font.SIZE_SMALL);
                }
            g.setColor(g.getColorOfName(textColor));
            drawStringInRect(g,font,label,0,i*recHeight,getWidth(),recHeight);
             g.setColor(g.getColorOfName(g.BLACK));
            g.drawRect(0,i*recHeight,getWidth(),recHeight);
        }
        
       
        g.drawRect(0,0,getWidth()-1,getHeight()-1);

    }

    public String getHex(int color){
        String label=Integer.toHexString(color);
        while(label.length()<6){
            label="0"+label;
        }
        label=label.substring(0,2)+" "+label.substring(2,4)+" "+label.substring(4,6);
        return label;
    }

    public void doUp(){
        // selectY=(selectY+1)%5;
        selectY=(selectY+1)%140;
        
    }

    public void doDown(){
        //  selectY--;
        //  if(selectY<0)
        //  selectY=0;
        selectY--;
        if(selectY<0)
            selectY=139;
    }

    public void doLeft(){
        page--;
        if(page<0)
        page=27;
    }

    public void doRight(){
        page=(page+1)%28;
    }

    public void doSelect(){
        if(isHex)
        isHex=false;
        else
        isHex=true;
    }

    /*
    public void doTimer(){

    }
*/
    public void doSoft1(){
        doExit();
    }

    public void doSoft2(){
        changeColor();
    }

         public void doExit(){
            IApplication.getCurrentApp().terminate();
        }
        
    public void processEvent(int type,int param){
        if(type==Display.KEY_PRESSED_EVENT){
            if(param==Display.KEY_UP){
                doUp();
            }
            else if(param==Display.KEY_DOWN){
                doDown();
            }
            else if(param==16){// Display.KEY_LEFT
                doLeft();
            }
            else if(param==Display.KEY_RIGHT){
                doRight();
            }
            else if(param==20){// Display.KEY_SELECT BUG
                doSelect();
            }else if(param==Display.KEY_SOFT1){
                doSoft1();

            }else if(param==Display.KEY_SOFT2){
                 doSoft2();
            }
            repaint();

        }else if(type==Display.TIMER_EXPIRED_EVENT){
           // doTimer();
        }
    }


}